"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var react_1 = __importDefault(require("react"));
var application_1 = require("../application");
var layout_1 = require("../layout");
exports.default = {
    name: "envs",
    component: /** @class */ (function (_super) {
        __extends(class_1, _super);
        function class_1() {
            var _this = _super !== null && _super.apply(this, arguments) || this;
            _this.updateLocation = function () {
                _this.setState("location", parseLocation(window.location.hash));
            };
            return _this;
        }
        class_1.prototype.pluginWillMount = function () {
            application_1.Application.envs = this;
            application_1.Application.connectEnv = connectEnv.bind(application_1.Application);
            window.addEventListener("hashchange", this.updateLocation);
            this.updateLocation();
        };
        return class_1;
    }(layout_1.PluginInstance)),
};
function connectEnv(mapping, ConnectedComponent) {
    return function (props) {
        return (react_1.default.createElement(ConnectedComponent, __assign({}, props)));
    };
}
function parseLocation(location) {
    if (typeof location === "string") {
        var locParts = location.split("?");
        location = {};
        location.url = locParts[0];
        location.params = {};
        if (locParts[1]) {
            locParts[1].split("&").forEach(function (param) {
                var parts = param.split("=");
                location.params[parts[0]] = parts[1];
            });
        }
    }
    else if (location) {
        var hash_1 = location.url;
        var isFirst_1 = true;
        if (location.params) {
            hash_1 += "?";
            Object.keys(location.params).forEach(function (key) {
                var param = location.params[key];
                if (isFirst_1)
                    isFirst_1 = false;
                else
                    hash_1 += "&";
                hash_1 += key + "=" + param;
            });
        }
        window.location.hash = hash_1;
    }
    return location;
}
