"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var react_1 = __importDefault(require("react"));
var react_dom_1 = __importDefault(require("react-dom"));
var application_1 = require("../application");
var layout_1 = require("../layout");
exports.default = {
    name: "popup-addon",
    component: /** @class */ (function (_super) {
        __extends(class_1, _super);
        function class_1() {
            var _this = _super !== null && _super.apply(this, arguments) || this;
            _this.modalStack = [];
            return _this;
        }
        class_1.prototype.pluginWillMount = function () {
            application_1.Application.popup = this.popup.bind(this);
        };
        class_1.prototype.popup = function (renderer, outsideReject) {
            var _this = this;
            return new Promise(function (resolve, reject) {
                var htmlRoot = document.createElement("div");
                htmlRoot.style.position = "absolute";
                htmlRoot.style.left = "0px";
                htmlRoot.style.top = "0px";
                htmlRoot.style.zIndex = (_this.modalStack.length * 1000 + 1000).toString();
                document.body.appendChild(htmlRoot);
                function handleResolve(data) {
                    document.body.removeChild(htmlRoot);
                    resolve(data);
                }
                function handleReject(data) {
                    document.body.removeChild(htmlRoot);
                    reject(data);
                }
                function handleStopPropagation(evt) {
                    evt.stopPropagation();
                }
                react_dom_1.default.render((react_1.default.createElement("div", null,
                    react_1.default.createElement("div", { style: styles.backdrop, className: "backdrop web-modal-dialog" }),
                    react_1.default.createElement("div", { style: styles.vWrapper, onClick: outsideReject && handleReject, className: "v-wrapper" },
                        react_1.default.createElement("div", { style: styles.hWrapper, className: "h-wrapper" },
                            react_1.default.createElement("div", { className: "modal-dialog", onClick: handleStopPropagation },
                                react_1.default.createElement("div", { className: "modal-content" },
                                    react_1.default.createElement("div", { className: "modal-body" }, renderer(handleResolve, handleReject)))))))), htmlRoot);
            });
        };
        return class_1;
    }(layout_1.PluginInstance)),
};
var styles = {
    backdropWrapper: {
        position: "fixed",
        height: "100%",
        width: "100%",
        zIndex: 999,
    },
    backdrop: {
        opacity: .5,
        position: "fixed",
        height: "100%",
        width: "100%",
        zIndex: 998,
        backgroundColor: "#333",
    },
    vWrapper: {
        position: "fixed",
        height: "100%",
        width: "100%",
        zIndex: 999,
        flexDirection: "row",
        justifyContent: "center",
    },
    hWrapper: {
        height: "100%",
        flexDirection: "column",
        justifyContent: "center",
    },
    modalDialog: {
        width: 600,
        marginTop: 30,
        marginBottom: 30,
    },
    modalContent: {
        marginLeft: "auto",
        marginRight: "auto",
        width: 600,
        boxShadow: "0 5px 15px rgba(0,0,0,.5)",
        zIndex: 99999999,
        backgroundColor: "white",
        padding: 3,
        borderWidth: 1,
        borderColor: "rgba(0,0,0,.2)",
        borderRadius: 6,
    },
    modalHeader: {
        padding: 10,
        borderBottomColor: "#e5e5e5",
        borderBottomWidth: 1,
        flex: 1,
        flexDirection: "row",
    },
    close: {
        cursor: "pointer",
    },
    modalBody: {
        position: "relative",
        padding: 10,
    },
    modalFooter: {
        padding: 10,
        alignItems: "flex-end",
        borderTopWidth: 1,
        borderColor: "#e5e5e5",
    },
};
