import React from "react";
import { PluginInstance, PluginClass } from "./Plugin";
import { WindowInstance, WindowClass, WindowOptions } from "./Window";
export interface IApplicationFrame {
    attachWindow(wnd: WindowInstance, dockId: string, foreground?: boolean): void;
    dettachWindow(wnd: WindowInstance): void;
    getFrameComponent(): React.Component;
    renderFrameComponent(): void;
}
export declare class PluginContext {
    pluginClasses: {
        [key: string]: PluginClass;
    };
    plugins: {
        [key: string]: PluginInstance;
    };
    windowsDocks: {
        [windowClassId: string]: string;
    };
    windows: {
        [key: string]: WindowInstance;
    };
    docks: {
        [key: string]: Array<WindowInstance>;
    };
    focused: WindowInstance;
    frame: IApplicationFrame;
    uidGenerator: number;
    constructor();
    mountPlugins: () => void;
    unmountPlugins: () => void;
    mapPlugin(name: any): PluginClass;
    installPlugin(description: any, parameters: any): PluginClass;
    declarePlugin(description: any, parameters: any): PluginClass;
    mountPlugin(name: string): PluginClass;
    dockWindow(wnd: WindowInstance, dockId: string, foreground: boolean): void;
    dettachWindow(wnd: WindowInstance): void;
    removeWindow(wnd: WindowInstance): void;
    openSubWindow(windowClass: WindowClass, parent: WindowInstance, options: WindowOptions): void;
    openPluginWindow(windowClass: WindowClass, plugin: PluginInstance, options: WindowOptions): void;
    closePluginWindows(windowClass: WindowClass, plugin: PluginInstance): void;
    getWindowInstance(windowId: string): WindowInstance;
    findOneWindowByClass(windowClass: WindowClass): WindowInstance;
    findAllWindowsByPlugin(plugin: PluginInstance): Array<WindowInstance>;
    findAllWindowsByClass(windowClass: WindowClass): WindowInstance[];
}
