import Listenable from "../modules/listenable";
import { WindowClass } from "./Window";
import { PluginContext } from "./Context";
export declare class PluginClass {
    name: string;
    instance: PluginInstance;
    component: typeof PluginInstance;
    parameters: Object;
    windows: {
        [key: string]: WindowClass;
    };
    export: any[];
    import: {
        [key: string]: any;
    };
    context: PluginContext;
    users: Array<PluginClass>;
    dependencies: Array<PluginClass>;
    isMounted: boolean;
    menu: any;
    constructor(name: string, context: PluginContext);
    setup(desc: {
        [key: string]: any;
    }, parameters: {
        [key: string]: any;
    }): void;
    addUser(user: PluginClass): this;
    addDependency(name: string): PluginClass;
    raiseInvalid(): void;
    mount(): void;
    promptMount(): void;
    didMount(): void;
    resolveValueReference(reference: boolean | string, key: string): {
        pluginName: any;
        path: any;
    };
}
export declare class PluginInstance extends Listenable {
    ".class": PluginClass;
    openWindow: Function;
    closeWindow: Function;
    closeAllWindow: Function;
    pluginWillMount(parameters: {
        [key: string]: any;
    }): void;
    pluginDidMount(parameters: {
        [key: string]: any;
    }): void;
    pluginWillUnmount(): void;
    constructor(pluginClass: PluginClass);
}
