declare type ListenersArray = (Function | string)[];
export declare type ListenableContexts = {
    [contextName: string]: any;
};
export declare type ListenableResult = Promise<Listenable> | Listenable | null;
export default class Listenable {
    ".events": any[];
    ".listeners": ListenersArray;
    addEventListener(callback: Function): boolean;
    addEventListener(eventType: string, callback: Function): boolean;
    removeEventListener(callback: Function): boolean;
    removeEventListener(eventType: string, callback: Function): boolean;
    synchronizeStateInContext(contexts: ListenableContexts, // Collection of data, the listenable can access to it environment variable by key
    writable: boolean, // true when a writable listenable is required for the resulting listenable
    fields?: string[] | boolean, // fields required in the resulting listenable
    previousResult?: Listenable): Promise<Listenable> | Listenable;
    addStateListener(callback: Function, fields?: string[]): boolean;
    removeStateListener(callback: Function): boolean;
    setState(): void;
    setState(key: string, value: any): void;
    setState(values: {
        [key: string]: any;
    }): void;
    dispatchEvent(type: string, data?: any): void;
    executeEvent(type: string, data?: any): Promise<any[]>;
    static setState(): void;
    static setState(key: string, value: any): void;
    static setState(values: {
        [key: string]: any;
    }): void;
}
export {};
