"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var application_1 = require("../application");
var Connector = /** @class */ (function () {
    function Connector() {
    }
    Connector.prototype.fetchModule = function (guid) {
        return application_1.Application.fetchAPI("app:/webfile.pack?guid=" + guid)
            .then(function (res) {
            return res.json;
        });
    };
    Connector.prototype.fetchFileInfos = function (name) {
        return application_1.Application.fetchAPI("app:/model" + (name || "/"), {
            method: "GET",
            mode: "cors",
        })
            .then(function (res) {
            return res.json;
        });
    };
    Connector.prototype.createFileByName = function (name, descriptor) {
        if (typeof descriptor !== "object" ||
            typeof descriptor.type !== "string" ||
            typeof name !== "string") {
            throw new Error("bad create file arguments");
        }
        return application_1.Application.fetchAPI("app:/webfile/" + name, {
            method: "PUT",
            body: descriptor,
        });
    };
    Connector.prototype.deleteFileByName = function (name) {
        return application_1.Application.fetchAPI("app:/webfile/" + name, {
            method: "DELETE",
        });
    };
    Connector.prototype.writeFile = function (guid, resources) {
        return application_1.Application.fetchAPI("app:/webfile?guid=" + guid, {
            method: "POST",
            body: resources,
        });
    };
    Connector.prototype.deleteFile = function (guid) {
        /*if (this.register[guid]) {
          // TODO: manage deletion of mounted file
        } */
        return application_1.Application.fetchAPI("app:/webfile?guid=" + guid, {
            method: "DELETE",
        });
    };
    return Connector;
}());
exports.default = Connector;
