"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var base_64_1 = __importDefault(require("base-64"));
var Connector_1 = __importDefault(require("./Connector"));
var compileScript = eval;
var defaultImports = {
    "icon": require("./Icon.js"),
};
var Export = /** @class */ (function () {
    function Export() {
        this.__esModule = true;
    }
    return Export;
}());
exports.Export = Export;
var Module = /** @class */ (function (_super) {
    __extends(Module, _super);
    function Module() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    return Module;
}(Export));
exports.Module = Module;
var SandBox = /** @class */ (function () {
    function SandBox(name) {
        var _this = this;
        this.modules = {};
        this.require = function (ref) {
            var resolved = _this.modules[ref];
            if (!resolved)
                new Error("Require module '" + ref + "' is not found.");
            return resolved;
        };
        if (typeof name !== "string")
            throw new Error();
        this.name = name;
        this.devMode = true;
        this.connector = new Connector_1.default();
        this.imports(defaultImports);
    }
    SandBox.prototype.reset = function () {
        this.modules = {};
    };
    SandBox.prototype.imports = function (cimports) {
        for (var guid in cimports) {
            var cimport = cimports[guid];
            var cmodule = this.getModule(guid);
            if (cmodule.$ === null) {
                cmodule.$ = true;
                if (!cimport.__esSandboxExport) {
                    Object.assign(cmodule, cimport);
                }
                else {
                    cimport.__esSandboxExport(cmodule, this);
                }
                if (cmodule.default === undefined) {
                    cmodule.default = cmodule;
                }
            }
            else
                console.error(guid, "is imported more than once.");
        }
    };
    SandBox.prototype.getModulesRegister = function () {
        return this.modules;
    };
    SandBox.prototype.getModule = function (guid) {
        var cmodule = this.modules[guid];
        if (!cmodule) {
            cmodule = new Module();
            cmodule[".sandbox"] = this;
            if (this.devMode) {
                cmodule[".guid"] = guid;
            }
            this.modules[guid] = cmodule;
        }
        return cmodule;
    };
    SandBox.prototype.getModuleGuid = function (cmodule) {
        for (var guid in this.modules) {
            if (this.modules[guid] === cmodule)
                return guid;
        }
    };
    SandBox.prototype.installModule = function (cmodule) {
        var _this = this;
        if (!cmodule)
            throw new Error("module is undefined");
        if (cmodule.$ === null) {
            var guid = this.getModuleGuid(cmodule);
            return cmodule.$ = this.connector.fetchModule(guid)
                .then(function (data) {
                installPack(_this, data);
                return cmodule;
            });
        }
        else if (cmodule.$ instanceof Promise) {
            return cmodule.$;
        }
    };
    return SandBox;
}());
exports.SandBox = SandBox;
function installPack(context, data) {
    for (var _i = 0, _a = data.modules; _i < _a.length; _i++) {
        var cmodule = _a[_i];
        installModule(context, cmodule);
    }
}
function installModule(context, data) {
    var objectsCount = data.objects ? data.objects.length : 0;
    // Create object export register
    var cmodule = context.getModule(data.name);
    if (data.type)
        cmodule[".type"] = data.type;
    var register = [cmodule];
    for (var i = 1; i < objectsCount; i++) {
        register.push({});
    }
    cmodule.$ = register;
    function installJs(obj, cexports) {
        var code = obj.data;
        // Append source map
        if (obj.mappings && obj.names && obj.source) {
            code += "\n//# sourceMappingURL=data:application/json;charset=utf-8;base64,";
            code += base_64_1.default.encode(JSON.stringify({
                version: 3,
                sources: [obj.location],
                sourceRoot: "/" + context.name + "/" + data.name,
                sourcesContent: [obj.source],
                mappings: obj.mappings,
                names: obj.names,
            }));
        }
        // Eval & call module constructor
        var constructor = compileScript(code);
        try {
            if (constructor instanceof Function) {
                constructor(cmodule, cexports, context.require);
            }
        }
        catch (e) {
            console.error("in " + data.name + " (" + obj.location + ") : ", e, constructor);
        }
        return cexports;
    }
    function installCss(obj) {
        var head = document.getElementsByTagName("head")[0];
        var style = document.createElement("style");
        style.setAttribute("type", "text/css");
        if (style.styleSheet) { // IE
            style.styleSheet.cssText = obj.data;
        }
        else { // the world
            style.appendChild(document.createTextNode(obj.data));
        }
        head.appendChild(style);
    }
    function installImage(obj, cexports) {
        cexports.default = obj.data;
    }
    // Install each object
    for (var i = 0; i < objectsCount; i++) {
        var obj = data.objects[i];
        var cexports = register[obj.id];
        try {
            switch (obj.type) {
                case "js":
                    installJs(obj, cexports);
                    break;
                case "css":
                    installCss(obj);
                    break;
                case "image":
                    installImage(obj, cexports);
                    break;
                default:
                    throw new Error("unkwnow '" + obj.type + "'");
            }
        }
        catch (e) {
            cmodule.__error = e.toString();
            console.error("in " + data.name + " (" + obj.location + ") : ", e, obj, obj.data);
            return cmodule;
        }
    }
    return cmodule;
}
