"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var react_1 = __importDefault(require("react"));
var ResizableBorder_1 = require("../ResizableBorder");
require("./index.css");
var LinearContainer = /** @class */ (function (_super) {
    __extends(LinearContainer, _super);
    function LinearContainer() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.delta = 0.0;
        _this.onResize = function (i_1) { return function (gap) {
            var _a = _this.props, value = _a.value, vertical = _a.vertical;
            var container = _this.refs.container;
            var container_size = vertical ? container.clientWidth : container.clientHeight;
            if (container_size < 1)
                return;
            var i_0 = i_1 - 1;
            var size_0 = value[i_0].size ? value[i_0].size : 100.0;
            var size_1 = value[i_1].size ? value[i_1].size : 100.0;
            var size_factor = _this.getSizeFactor();
            _this.delta -= 100.0 * gap / (size_factor * container_size);
            var items = _this.refs;
            if (vertical) {
                items[i_0].style.minWidth = (size_factor * (size_0 - _this.delta)) + "%";
                items[i_1].style.minWidth = (size_factor * (size_1 + _this.delta)) + "%";
            }
            else {
                items[i_0].style.minHeight = (size_factor * (size_0 - _this.delta)) + "%";
                items[i_1].style.minHeight = (size_factor * (size_1 + _this.delta)) + "%";
            }
        }; };
        _this.onRelease = function (i_1) { return function () {
            var _a = _this.props, value = _a.value, onChange = _a.onChange;
            var new_value = value.slice();
            var i_0 = i_1 - 1;
            new_value[i_0] = __assign({}, new_value[i_0], { size: value[i_0].size - _this.delta });
            new_value[i_1] = __assign({}, new_value[i_1], { size: value[i_1].size + _this.delta });
            _this.delta = 0.0;
            onChange(new_value);
        }; };
        return _this;
    }
    LinearContainer.prototype.getSizeFactor = function () {
        var value = this.props.value;
        var sizes_sum = 0;
        for (var i = 0; i < value.length; i++) {
            var size = value[i].size;
            sizes_sum += size ? size : 100.0;
        }
        return 100.0 / sizes_sum;
    };
    LinearContainer.prototype.render = function () {
        var _a = this.props, value = _a.value, vertical = _a.vertical, children = _a.children, style = _a.style, className = _a.className, onChange = _a.onChange;
        if (value && children) {
            var content = [];
            var size_factor = this.getSizeFactor();
            for (var i = 0; i < value.length; i++) {
                var display = children(value[i]);
                var size = value[i].size;
                var style_1 = void 0;
                if (vertical) {
                    style_1 = { minWidth: (size_factor * (size ? size : 100.0)) + "%" };
                }
                else {
                    style_1 = { minHeight: (size_factor * (size ? size : 100.0)) + "%" };
                }
                if (i > 0) {
                    if (onChange) {
                        content.push(react_1.default.createElement(ResizableBorder_1.ResizableBorder, { key: content.length, vertical: vertical, onResize: this.onResize(i), onRelease: this.onRelease(i) }));
                    }
                    else
                        content.push(react_1.default.createElement(ResizableBorder_1.ResizableBorder, { key: content.length }));
                }
                content.push(react_1.default.createElement("div", { key: display.key || content.length, ref: i, style: style_1 },
                    react_1.default.createElement("div", null, display.header),
                    react_1.default.createElement("div", null, display.content)));
            }
            return (react_1.default.createElement("div", { ref: "container", className: (vertical ? className_V : className_H) + (className || ""), style: style }, content));
        }
    };
    return LinearContainer;
}(react_1.default.Component));
exports.default = LinearContainer;
var className_V = "wfs-linear-container vertical ";
var className_H = "wfs-linear-container horizontal ";
