"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var react_1 = __importDefault(require("react"));
var event_utils_1 = require("../event.utils");
require("./index.css");
var ResizableBorder = /** @class */ (function (_super) {
    __extends(ResizableBorder, _super);
    function ResizableBorder() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.handleMouseDown = function (e) {
            new event_utils_1.HtmlGrabReaction(e.target, e, _this.handleMouseGrab, _this.handleMouseRelease);
        };
        _this.handleMouseGrab = function (e) {
            var _a = _this.props, onResize = _a.onResize, transformDelta = _a.transformDelta, vertical = _a.vertical;
            onResize && onResize(transformDelta ? transformDelta(e) : (vertical ? e.deltaX : e.deltaY));
        };
        _this.handleMouseRelease = function (e) {
            var _a = _this.props, onRelease = _a.onRelease, transformDelta = _a.transformDelta, vertical = _a.vertical;
            onRelease && onRelease(transformDelta ? transformDelta(e) : (vertical ? e.deltaX : e.deltaY));
        };
        return _this;
    }
    ResizableBorder.prototype.render = function () {
        var vertical = this.props.vertical;
        return (react_1.default.createElement("div", { className: vertical ? "wfs-resizer-border vertical" : "wfs-resizer-border horizontal", onMouseDown: this.handleMouseDown },
            react_1.default.createElement("div", null)));
    };
    return ResizableBorder;
}(react_1.default.Component));
exports.ResizableBorder = ResizableBorder;
