"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
    result["default"] = mod;
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
var react_1 = __importStar(require("react"));
var openContextualMenu_1 = __importStar(require("../openContextualMenu"));
var application_1 = require("../../application");
var FrameMenu = /** @class */ (function (_super) {
    __extends(FrameMenu, _super);
    function FrameMenu() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.handleClick = function (plugin, windowName) { return function () {
            plugin.openWindow(windowName);
            _this.props.close();
        }; };
        _this.handleMenu = function (e) {
            var open = application_1.Application.openContextualMenu || openContextualMenu_1.default;
            open(_this, e, function (f) {
                var plugins = application_1.Application.layout.plugins;
                var list = [];
                for (var pluginName in plugins) {
                    var plugin = plugins[pluginName];
                    var windows = plugin[".class"].windows;
                    for (var name_1 in windows) {
                        var _a = windows[name_1], userOpenable = _a.userOpenable, defaultIcon = _a.defaultIcon, defaultTitle = _a.defaultTitle;
                        userOpenable && list.push(react_1.default.createElement(openContextualMenu_1.Menu.Item, { key: list.length, onClick: _this.handleClick(plugin, name_1), icon: react_1.default.createElement("i", { className: "fa fa-" + defaultIcon }), title: defaultTitle || name_1 }));
                    }
                }
                return (react_1.default.createElement("div", { className: "text-bold" }, list));
            }, "right-down");
        };
        return _this;
    }
    FrameMenu.prototype.getWindowsCount = function () {
        var count = 0;
        var plugins = application_1.Application.layout.plugins;
        for (var pluginName in plugins) {
            var plugin = plugins[pluginName];
            var windows = plugin[".class"].windows;
            for (var name_2 in windows) {
                var userOpenable = windows[name_2].userOpenable;
                if (userOpenable)
                    count++;
            }
        }
        return count;
    };
    FrameMenu.prototype.render = function () {
        var plugins = application_1.Application.layout.plugins;
        var menuItems = [];
        for (var name_3 in plugins) {
            var plugin = plugins[name_3];
            var menu = plugin[".class"].menu;
            if (menu && menu.component) {
                menuItems.push(react_1.default.createElement(menu.component, { key: name_3, plugin: plugin, onClose: this.props.close }));
            }
        }
        if (this.getWindowsCount() > 0) {
            menuItems.push(react_1.default.createElement(openContextualMenu_1.Menu.Item, { key: ".", onClick: this.handleMenu, icon: react_1.default.createElement("i", { className: "fa fa-window-restore" }), title: "Windows" }));
        }
        return (react_1.default.createElement(react_1.default.Fragment, null, menuItems.length
            ? menuItems
            : react_1.default.createElement("span", { style: { color: "#aaa" } }, "No Items")));
    };
    return FrameMenu;
}(react_1.Component));
function openFrameMenu(e) {
    var open = application_1.Application.openContextualMenu || openContextualMenu_1.default;
    open(this, e, function (f) {
        return (react_1.default.createElement(FrameMenu, { close: f }));
    });
}
exports.openFrameMenu = openFrameMenu;
