"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
    result["default"] = mod;
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var react_1 = __importStar(require("react"));
var DragAndDrop_1 = require("../DragAndDrop");
var application_1 = require("../../application");
var Menu_1 = require("./Menu");
var PanelButton_1 = __importDefault(require("./PanelButton"));
var CSS_panel_bar_horizontal = {
    bar: "WND_panel_bar WND_panel_bar_H",
    menu_btn: "WND_panel_menu_btn WND_panel_menu_btn_H WND_center_vertical",
    item_button: "WND_panel_button WND_panel_button_H",
    item_button_CURRENT: "WND_panel_button WND_panel_button_H current",
    item_button_FOCUSED: "WND_panel_button WND_panel_button_H current focused",
    item_button_transform: "rotate(0deg)",
};
var CSS_panel_bar_vertical = {
    bar: "WND_panel_bar WND_panel_bar_V",
    menu_btn: "WND_panel_menu_btn WND_panel_menu_btn_V WND_center_horizontal",
    item_button: "WND_panel_button WND_panel_button_V",
    item_button_CURRENT: "WND_panel_button WND_panel_button_V current",
    item_button_FOCUSED: "WND_panel_button WND_panel_button_V current focused",
    item_button_transform: "rotate(-90deg)",
};
var PanelBar = /** @class */ (function (_super) {
    __extends(PanelBar, _super);
    function PanelBar() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.handleDropWindow = function (data) {
            if (data["window"]) {
                var wnd = application_1.Application.layout.getWindowInstance(data.window.id);
                wnd.windowClass.setDefaultDockId(_this.props.panel.id);
                wnd && application_1.Application.layout.dockWindow(wnd, _this.props.panel.id, true);
            }
        };
        return _this;
    }
    PanelBar.prototype.shouldComponentUpdate = function (nextProps) {
        var curProps = this.props;
        return curProps.panel !== nextProps.panel
            || curProps.vertical !== nextProps.vertical;
    };
    PanelBar.prototype.render = function () {
        var _a = this.props, panel = _a.panel, frame = _a.frame, vertical = _a.vertical;
        var css = vertical ? CSS_panel_bar_vertical : CSS_panel_bar_horizontal;
        // Bar render
        return (react_1.default.createElement(DragAndDrop_1.DropZone, { onDrop: this.handleDropWindow, className: css.bar },
            panel.menu &&
                react_1.default.createElement("div", { className: css.menu_btn + " fa fa-caret-down", onClick: Menu_1.openFrameMenu }),
            panel.items.map(function (item, i) {
                return (react_1.default.createElement(PanelButton_1.default, { key: i, css: css, item: item, panel: panel, frame: frame }));
            })));
    };
    return PanelBar;
}(react_1.Component));
exports.default = PanelBar;
