"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
    result["default"] = mod;
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
var react_1 = __importStar(require("react"));
var DragAndDrop_1 = require("../DragAndDrop");
var event_utils_1 = require("../event.utils");
var application_1 = require("../../application");
var CSS_panel_button_animation = {
    "danger": " WND_panel_button_danger",
    "warning": " WND_panel_button_warning",
};
var PanelButton = /** @class */ (function (_super) {
    __extends(PanelButton, _super);
    function PanelButton() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.handleEvent = function () {
            _this.forceUpdate();
        };
        _this.handleClick = function () {
            var _a = _this.props, item = _a.item, panel = _a.panel, frame = _a.frame;
            if (item === panel.current) {
                frame.hideWindow(item);
            }
            else {
                if (item.animation)
                    item.updateTitle();
                frame.showWindow(item);
            }
        };
        _this.handleDragWindow = function () {
            return {
                "window": { id: _this.props.item.id }
            };
        };
        _this.handleDragMatch = function (types) {
            if (types.find(function (x) { return x === "window"; })) {
                return true;
            }
            var _a = _this.props, item = _a.item, panel = _a.panel;
            if (panel.current !== item)
                _this.handleClick();
            return false;
        };
        _this.handleClose = function (e) {
            if (e.button === 1) {
                event_utils_1.stopEvent(e);
                var item = _this.props.item;
                application_1.Application.layout.removeWindow(item);
            }
        };
        return _this;
    }
    PanelButton.prototype.componentWillMount = function () {
        this.props.item.addEventListener("update", this.handleEvent);
    };
    PanelButton.prototype.componentWillUnmount = function () {
        this.props.item.removeEventListener(this.handleEvent);
    };
    PanelButton.prototype.render = function () {
        var _a = this.props, item = _a.item, panel = _a.panel, css = _a.css;
        var className = (panel.current !== item)
            ? css.item_button
            : (item.hasFocus
                ? css.item_button_FOCUSED
                : css.item_button_CURRENT);
        if (item.animation) {
            className += CSS_panel_button_animation[item.animation.mode] || "";
        }
        return (react_1.default.createElement(DragAndDrop_1.DragDropZone, { className: className, title: item.title, onDragStart: this.handleDragWindow, onDropMatch: this.handleDragMatch, onClick: this.handleClick, onMouseDown: this.handleClose }, item.window &&
            react_1.default.createElement("div", { style: { transform: css.item_button_transform } }, item.window.renderWindowTitle())));
    };
    return PanelButton;
}(react_1.Component));
exports.default = PanelButton;
