"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
    result["default"] = mod;
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var react_1 = __importStar(require("react"));
var ResizableBorder_1 = require("../ResizableBorder");
var PanelContainers_1 = require("./PanelContainers");
var PanelBar_1 = __importDefault(require("./PanelBar"));
var CSS_side_panel_vertical = "WND_side_panel WND_side_panel_V";
var CSS_side_panel_horizontal = "WND_side_panel WND_side_panel_H";
var SidePanel = /** @class */ (function (_super) {
    __extends(SidePanel, _super);
    function SidePanel() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.handleResize = function (delta) {
            var container = _this.refs.container;
            var csize = container.getSize();
            if (csize !== undefined) {
                var size = _this.props.panel.size;
                size += Math.max(size, 1) * delta / Math.max(csize, 1);
                size = Math.min(Math.max(size, 0), 100);
                _this.props.frame.notifyPanelResize(_this.props.panel, size);
            }
        };
        return _this;
    }
    SidePanel.prototype.shouldComponentUpdate = function (nextProps) {
        var curProps = this.props;
        return curProps.panel !== nextProps.panel
            || curProps.frame !== nextProps.frame
            || curProps.children !== nextProps.children;
    };
    return SidePanel;
}(react_1.Component));
var SidePanelTop = /** @class */ (function (_super) {
    __extends(SidePanelTop, _super);
    function SidePanelTop() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    SidePanelTop.prototype.transformDelta = function (e) {
        return e.deltaY;
    };
    SidePanelTop.prototype.render = function () {
        var _a = this.props, panel = _a.panel, frame = _a.frame;
        var size = panel.current ? panel.size : 0;
        return (react_1.default.createElement("div", { className: CSS_side_panel_horizontal },
            react_1.default.createElement(PanelBar_1.default, { panel: panel, frame: frame }),
            react_1.default.createElement(PanelContainers_1.SidePanelContainer, { ref: "container", current: panel.current, size: size }),
            react_1.default.createElement(ResizableBorder_1.ResizableBorder, { onResize: this.handleResize, transformDelta: this.transformDelta }),
            react_1.default.createElement("div", { className: "WND_panel_container_center" }, this.props.children)));
    };
    return SidePanelTop;
}(SidePanel));
exports.SidePanelTop = SidePanelTop;
var SidePanelBottom = /** @class */ (function (_super) {
    __extends(SidePanelBottom, _super);
    function SidePanelBottom() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    SidePanelBottom.prototype.transformDelta = function (e) {
        return -e.deltaY;
    };
    SidePanelBottom.prototype.render = function () {
        var _a = this.props, panel = _a.panel, frame = _a.frame;
        var size = panel.current ? panel.size : 0;
        return (react_1.default.createElement("div", { className: CSS_side_panel_horizontal },
            react_1.default.createElement("div", { className: "WND_panel_container_center" }, this.props.children),
            react_1.default.createElement(ResizableBorder_1.ResizableBorder, { onResize: this.handleResize, transformDelta: this.transformDelta }),
            react_1.default.createElement(PanelBar_1.default, { panel: panel, frame: frame }),
            react_1.default.createElement(PanelContainers_1.SidePanelContainer, { ref: "container", current: panel.current, size: size })));
    };
    return SidePanelBottom;
}(SidePanel));
exports.SidePanelBottom = SidePanelBottom;
var SidePanelLeft = /** @class */ (function (_super) {
    __extends(SidePanelLeft, _super);
    function SidePanelLeft() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    SidePanelLeft.prototype.transformDelta = function (e) {
        return e.deltaX;
    };
    SidePanelLeft.prototype.render = function () {
        var _a = this.props, panel = _a.panel, frame = _a.frame;
        var size = panel.current ? panel.size : 0;
        return (react_1.default.createElement("div", { className: CSS_side_panel_vertical },
            react_1.default.createElement(PanelBar_1.default, { vertical: true, panel: panel, frame: frame }),
            react_1.default.createElement(PanelContainers_1.SidePanelContainer, { ref: "container", vertical: true, current: panel.current, size: size }),
            react_1.default.createElement(ResizableBorder_1.ResizableBorder, { vertical: true, onResize: this.handleResize, transformDelta: this.transformDelta }),
            react_1.default.createElement("div", { className: "WND_panel_container_center" }, this.props.children)));
    };
    return SidePanelLeft;
}(SidePanel));
exports.SidePanelLeft = SidePanelLeft;
var SidePanelRight = /** @class */ (function (_super) {
    __extends(SidePanelRight, _super);
    function SidePanelRight() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    SidePanelRight.prototype.transformDelta = function (e) {
        return -e.deltaX;
    };
    SidePanelRight.prototype.render = function () {
        var _a = this.props, panel = _a.panel, frame = _a.frame;
        var size = panel.current ? panel.size : 0;
        return (react_1.default.createElement("div", { className: CSS_side_panel_vertical },
            react_1.default.createElement("div", { className: "WND_panel_container_center" }, this.props.children),
            react_1.default.createElement(ResizableBorder_1.ResizableBorder, { vertical: true, onResize: this.handleResize, transformDelta: this.transformDelta }),
            react_1.default.createElement(PanelContainers_1.SidePanelContainer, { ref: "container", vertical: true, current: panel.current, size: size }),
            react_1.default.createElement(PanelBar_1.default, { vertical: true, panel: panel, frame: frame })));
    };
    return SidePanelRight;
}(SidePanel));
exports.SidePanelRight = SidePanelRight;
var CenterPanelTop = /** @class */ (function (_super) {
    __extends(CenterPanelTop, _super);
    function CenterPanelTop() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    CenterPanelTop.prototype.render = function () {
        var _a = this.props, panel = _a.panel, frame = _a.frame;
        return (react_1.default.createElement("div", { className: CSS_side_panel_horizontal },
            react_1.default.createElement(PanelBar_1.default, { panel: panel, frame: frame }),
            react_1.default.createElement(PanelContainers_1.CenterPanelContainer, { ref: "container", current: panel.current })));
    };
    return CenterPanelTop;
}(SidePanelTop));
exports.CenterPanelTop = CenterPanelTop;
function RootPanel(props) {
    return (react_1.default.createElement("div", { className: "WND_root_panel", onContextMenu: preventContextMenu },
        " ",
        props.children,
        " "));
}
exports.RootPanel = RootPanel;
function preventContextMenu(e) {
    if (e.target.readOnly !== false) {
        e.preventDefault();
    }
    return true;
}
exports.default = {
    "#": RootPanel,
    "side-left": SidePanelLeft,
    "side-top": SidePanelTop,
    "side-right": SidePanelRight,
    "side-bottom": SidePanelBottom,
    "center-top": CenterPanelTop,
};
