"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var react_1 = __importDefault(require("react"));
var application_1 = require("../../application");
var Panels_1 = __importDefault(require("./Panels"));
require("./index.css");
var WindowedContainer = /** @class */ (function (_super) {
    __extends(WindowedContainer, _super);
    function WindowedContainer() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.loadDisplayLayout = function (displayLayout) {
            var panels = {};
            var _loop_1 = function (dockId) {
                var panelDesc = displayLayout[dockId];
                var panel = __assign({}, panelDesc, { id: dockId, current: application_1.Application.layout.getWindowInstance(panelDesc.current), items: [] });
                panelDesc.items && panelDesc.items.forEach(function (wid) {
                    var wnd = application_1.Application.layout.getWindowInstance(wid);
                    if (wnd) {
                        wnd.dockId = dockId;
                        panel.items.push(wnd);
                    }
                });
                panels[dockId] = panel;
            };
            for (var dockId in displayLayout) {
                _loop_1(dockId);
            }
            _this.setState({ panels: panels });
        };
        return _this;
    }
    WindowedContainer.prototype.componentWillMount = function () {
        this.loadDisplayLayout(this.props.displayLayout);
    };
    WindowedContainer.prototype.componentWillReceiveProps = function (nextProps) {
        if (this.props.displayLayout !== nextProps.displayLayout) {
            this.loadDisplayLayout(nextProps.displayLayout);
        }
    };
    WindowedContainer.prototype.showWindow = function (wnd) {
        var panels = this.state.panels;
        if (!wnd)
            return null;
        var origin = panels[wnd.dockId];
        if (origin) {
            panels[wnd.dockId] = __assign({}, origin, { current: wnd });
            this.setState({ panels: panels });
        }
    };
    WindowedContainer.prototype.hideWindow = function (wnd) {
        var panels = this.state.panels;
        if (!wnd)
            return null;
        var origin = panels[wnd.dockId];
        if (origin && origin.current === wnd) {
            panels[wnd.dockId] = __assign({}, origin, { current: null });
            this.setState({ panels: panels });
        }
    };
    WindowedContainer.prototype.dettachWindow = function (wnd) {
        var panels = this.state.panels;
        if (!wnd)
            return null;
        var origin = panels[wnd.dockId];
        if (origin) {
            origin = __assign({}, origin, { items: origin.items.filter(function (x) { return x !== wnd; }) });
            if (origin.current === wnd)
                origin.current = origin.items[0];
            panels[wnd.dockId] = origin;
            this.setState({ panels: panels });
        }
        wnd.dockId = null;
    };
    WindowedContainer.prototype.attachWindow = function (wnd, dockId, foreground) {
        var panels = this.state.panels;
        if (!wnd)
            return null;
        // Detach from origin panel
        if (wnd.dockId !== dockId) {
            var origin_1 = panels[wnd.dockId];
            if (origin_1 && origin_1.items.indexOf(wnd) >= 0) {
                origin_1 = __assign({}, origin_1, { items: origin_1.items.filter(function (x) { return x !== wnd; }) });
                if (origin_1.current === wnd)
                    origin_1.current = origin_1.items[0];
                panels[wnd.dockId] = origin_1;
            }
        }
        // Attach to target panel
        var panel = panels[dockId];
        if (panel) {
            panel = __assign({}, panel);
            if (panel.items.indexOf(wnd) < 0) {
                panel.items = panel.items.concat([wnd]);
            }
            panel.current = foreground ? (wnd || panel.current) : (panel.current || wnd);
            panels[dockId] = panel;
        }
        wnd.dockId = dockId;
        this.setState({ panels: panels });
    };
    WindowedContainer.prototype.notifyPanelResize = function (panel, size) {
        var panels = this.state.panels;
        panels[panel.id] = __assign({}, panel, { size: size });
        this.setState({ panels: panels });
    };
    WindowedContainer.prototype.renderPanel = function (id) {
        var panel = this.state.panels[id];
        return react_1.default.createElement(Panels_1.default[panel.type] || Panels_1.default["#"], {
            id: id,
            frame: this,
            panel: panel,
            children: panel.child && this.renderPanel(panel.child),
        });
    };
    WindowedContainer.prototype.render = function () {
        return this.renderPanel("#");
    };
    return WindowedContainer;
}(react_1.default.Component));
exports.default = WindowedContainer;
