"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
function injectConstantsInto(clazz, constants) {
    if (!Array.isArray(clazz))
        clazz = [clazz];
    Object.keys(constants).forEach(function (key) {
        clazz.forEach(function (cls) {
            Object.defineProperty(cls.prototype, key, {
                value: constants[key],
                writable: false,
                enumerable: false,
                configurable: false,
            });
        });
    });
}
exports.injectConstantsInto = injectConstantsInto;
function isInheritedOf(What, Of) {
    while (What) {
        What = Object.getPrototypeOf(What);
        if (What === Of)
            return true;
    }
    return false;
}
exports.isInheritedOf = isInheritedOf;
function isClass(value) {
    return typeof value === "function" && value.prototype.constructor === value;
}
exports.isClass = isClass;
